;
;                                                      --Ŀ
;                  [http://www.ifrance.com/royale2000]ͻ 
;                  ĿĿĿĿĿ  Ŀ  |
;                .                Ŀ          
;                :                   Ĵ  :
;                    ٳ   Ŀ ٳ    Ŀ      .
;                |           
;                 [1999][royale2000@ifrance.com]ͼ
;                -- 
;
;                  ͻ
;                   Calcul de PI 100 % Assembleur par Royale 
;                  ļ
;
; Formule de calcul utilise :
;
;                1    1 x 3    1 x 3 x 5        
; PI = 3 x  1 +  +  +  + ... 
;               4x6   4x6x8x10   4x6x8x10x12x14       
;
; On peut dfinir la suite :
;   Uo = 3
;                (2n-1)
;   Un = Un-1 x 
;               8n(2n+1)
;
; Alors PI = Uo + U1 + U2 + U3 + ...
;

.386

NBDECIMALES equ 1000                  ; NOMBRE DE DECIMALES JUSTES !

half equ NBDECIMALES/2                ; Nombre de dcimales justes /2
max equ half+100                      ; Nombre de dcimales calcules /2
cmptlim equ max*10/3                  ; Nombre de dcimales calcules x(5/3)

pile segment para stack
  db 100 dup (?)
pile ends

temp segment para
  db 3,0FFFFh dup (0)
temp ends

pi segment para
  db 3,0FFFFh dup (0)
pi ends

code segment use16
     assume cs:code

compteur dd 0
facteur dd 0
outfile db 'pi.txt',0
virgule db ','
buffer dw 0
zeropos dw 0

;*** pi=pi+temp **
addi:
  std
  mov di,max
  mov si,max
  xor al,al
 boucle_a:
  add al,ds:[si]
  add al,es:[di]
  cmp al,99
 jna moins
  sub al,100
  stosb
  mov al,1                            ; al=retenue
  jmp fin
 moins:
  stosb
  xor al,al                           ; pas de retenue
 fin:
  dec si
  cmp si,zeropos
 jnz boucle_a
 cld
ret

;*** temp=temp*facteur ***
mult:
  mov si,max
  xor ebx,ebx
 boucle_m:
  xor eax,eax
  mov al,ds:[si]
  mul dword ptr cs:[facteur]
  add eax,ebx                         ; ajouter la retenue
  adc edx,0
  mov ebx,100
  div ebx
  mov ds:[si],dl                      ; total modulo 100
  mov ebx,eax                         ; bx=retenue
  dec si
  cmp si,zeropos
 jnz boucle_m
ret

;*** temp=temp/facteur ***
divi:
  mov si,zeropos
  xor edx,edx
 boucle_d:
  mov eax,edx                         ; retenue
  mov ebx,100
  mul ebx                             ; multiplie par 100
  xor bl,bl
  add al,ds:[si]
  adc ah,0
  adc bl,0
  shl ebx,16
  add eax,ebx                         ; "adc eah,0"
  xor edx,edx
  div dword ptr cs:[facteur]
  mov ds:[si],al
  inc si
  cmp si,max
 jnz boucle_d
ret

;*** faster ! ***
scanzero:
  mov si,zeropos
gozero:
  lodsb
  cmp si,max
  je maxfound
  or al,al
  jz gozero
maxfound:
  sub si,15
  mov zeropos,si
ret

;*** Calculer PI ***
compute:
  inc dword ptr cs:[compteur]
  mov eax,dword ptr cs:[compteur]
  shl eax,1
  sub eax,1                           ; *(2n-1)
  mov dword ptr cs:[facteur],eax
  call mult
  call mult
  call scanzero
  mov eax,dword ptr cs:[compteur]
  shl eax,3                           ; /8n
  mov dword ptr cs:[facteur],eax
  call divi
  mov eax,dword ptr cs:[compteur]
  shl eax,1                           ; /(2n+1)
  inc eax
  mov dword ptr cs:[facteur],eax
  call divi
  call addi                           ; pi<-pi+temp
  in al,60h
  cmp al,1
  je skip
  cmp byte ptr cs:[compteur],0
  jne nopoint
  mov ax,0e2ah
  int 10h
 nopoint:
  cmp dword ptr cs:[compteur],cmptlim ; maximum !
 jb compute
 skip:
ret

;*** Ecrire pi.txt ***
ecrire:
  push cs
  pop ds
  mov dx,offset outfile
  xor cx,cx
  mov ah,3Ch
  int 21h                             ; crer pi.big
  mov bx,ax                           ; sauver le handle
  mov al,es:[0]
  xor ah,ah
  mov cl,10
  div cl
  add ah,48
  mov byte ptr cs:[buffer],ah
  mov cx,1
  mov dx,offset buffer
  mov ah,40h
  int 21h                             ; crire '3' sans tricher :-)
  mov cx,1
  mov dx,offset virgule
  mov ah,40h
  int 21h                             ; crire la virgule
  mov word ptr cs:[facteur],half
  mov si,1
 ascii:
  push es
  pop ds
  lodsb
  xor ah,ah
  mov cl,10
  div cl
  add al,48
  mov byte ptr cs:[buffer],al
  mov al,ah
  add al,48
  mov byte ptr cs:[buffer+1],al
  push cs
  pop ds
  mov cx,2
  mov dx,offset buffer
  mov ah,40h
  int 21h                             ; crire les dcimales
  dec word ptr cs:[facteur]
 jnz ascii
  mov ah,3Eh
  int 21h
ret

;*** Programme principal ***
debut:
  mov ax,temp
  mov ds,ax
  mov ax,pi
  mov es,ax
  call compute
  call ecrire
  mov ax,4C00h
  int 21h

code ends

end debut
